Package org.springframework.expression.spel.support

# Class ReflectivePropertyAccessor

java.lang.Object
org.springframework.expression.spel.support.ReflectivePropertyAccessor

All Implemented Interfaces:
  `PropertyAccessor`, `TargetedAccessor`

Direct Known Subclasses:
  `DataBindingPropertyAccessor`

public class ReflectivePropertyAccessor extends Object implements PropertyAccessor
A powerful `PropertyAccessor` that uses reflection to access properties for reading and possibly also for writing on a target instance.

A property can be referenced through a public getter method (when being read) or a public setter method (when being written), and also through a public field.

Since:
  3.0
Author:
  Andy Clement, Juergen Hoeller, Phillip Webb, Sam Brannen, Sebastien Deleuze
See Also:
  - `StandardEvaluationContext`
  - `SimpleEvaluationContext`
  - `DataBindingPropertyAccessor`

## Constructor Summary

Constructors
Constructor
Description
`ReflectivePropertyAccessor()`
Create a new property accessor for reading as well as writing.
`ReflectivePropertyAccessor(boolean allowWrite)`
Create a new property accessor for reading and possibly also writing.

## Method Summary

Modifier and Type
Method
Description
`boolean`
`canRead(EvaluationContext context, Object target, String name)`
Called to determine if this property accessor is able to read a specified property on a specified target object.
`boolean`
`canWrite(EvaluationContext context, Object target, String name)`
Called to determine if this property accessor is able to write to a specified property on a specified target object.
`PropertyAccessor`
`createOptimalAccessor(EvaluationContext context, Object target, String name)`
Attempt to create an optimized property accessor tailored for a property of a particular name on a particular class.
`protected Field`
`findField(String name, Class<?> clazz, boolean mustBeStatic)`
Find a field of a certain name on a specified class.
`protected Method`
`findGetterForProperty(String propertyName, Class<?> clazz, boolean mustBeStatic)`
Find a getter method for the specified property.
`protected Method`
`findSetterForProperty(String propertyName, Class<?> clazz, boolean mustBeStatic)`
Find a setter method for the specified property.
`protected String`
`getPropertyMethodSuffix(String propertyName)`
Return the method suffix for a given property name.
`protected String[]`
`getPropertyMethodSuffixes(String propertyName)`
Return the method suffixes for a given property name.
`Class<?>[]`
`getSpecificTargetClasses()`
Returns `null` which means this is a general purpose accessor.
`protected boolean`
`isCandidateForProperty(Method method, Class<?> targetClass)`
Determine whether the given `Method` is a candidate for property access on an instance of the given target class.
`TypedValue`
`read(EvaluationContext context, Object target, String name)`
Called to read a property from a specified target object.
`void`
`write(EvaluationContext context, Object target, String name, Object newValue)`
Called to write to a property on a specified target object.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ReflectivePropertyAccessor

public ReflectivePropertyAccessor()
Create a new property accessor for reading as well as writing.

See Also:
  - `ReflectivePropertyAccessor(boolean)`

### ReflectivePropertyAccessor

public ReflectivePropertyAccessor(boolean allowWrite)
Create a new property accessor for reading and possibly also writing.

Parameters:
  `allowWrite` - whether to allow write operations on a target instance
Since:
  4.3.15
See Also:
  - `canWrite(org.springframework.expression.EvaluationContext, java.lang.Object, java.lang.String)`

## Method Details

### getSpecificTargetClasses

@Nullable public Class<?>[] getSpecificTargetClasses()
Returns `null` which means this is a general purpose accessor.

Specified by:
  `getSpecificTargetClasses` in interface `TargetedAccessor`
Returns:
  an array of classes that this accessor is suitable for (or `null` or an empty array if a generic accessor)

### canRead

public boolean canRead(EvaluationContext context, @Nullable Object target, String name) throws AccessException
Description copied from interface: `PropertyAccessor`
Called to determine if this property accessor is able to read a specified property on a specified target object.

Specified by:
  `canRead` in interface `PropertyAccessor`
Parameters:
  `context` - the evaluation context in which the access is being attempted
  `target` - the target object upon which the property is being accessed
  `name` - the name of the property being accessed
Returns:
  true if this property accessor is able to read the property
Throws:
  `AccessException` - if there is any problem determining whether the property can be read

### read

public TypedValue read(EvaluationContext context, @Nullable Object target, String name) throws AccessException
Description copied from interface: `PropertyAccessor`
Called to read a property from a specified target object.

Should only succeed if `PropertyAccessor.canRead(org.springframework.expression.EvaluationContext, java.lang.Object, java.lang.String)` also returns `true`.

Specified by:
  `read` in interface `PropertyAccessor`
Parameters:
  `context` - the evaluation context in which the access is being attempted
  `target` - the target object upon which the property is being accessed
  `name` - the name of the property being accessed
Returns:
  a TypedValue object wrapping the property value read and a type descriptor for it
Throws:
  `AccessException` - if there is any problem reading the property value

### canWrite

public boolean canWrite(EvaluationContext context, @Nullable Object target, String name) throws AccessException
Description copied from interface: `PropertyAccessor`
Called to determine if this property accessor is able to write to a specified property on a specified target object.

Specified by:
  `canWrite` in interface `PropertyAccessor`
Parameters:
  `context` - the evaluation context in which the access is being attempted
  `target` - the target object upon which the property is being accessed
  `name` - the name of the property being accessed
Returns:
  true if this property accessor is able to write to the property
Throws:
  `AccessException` - if there is any problem determining whether the property can be written to

### write

public void write(EvaluationContext context, @Nullable Object target, String name, @Nullable Object newValue) throws AccessException
Description copied from interface: `PropertyAccessor`
Called to write to a property on a specified target object.

Should only succeed if `PropertyAccessor.canWrite(org.springframework.expression.EvaluationContext, java.lang.Object, java.lang.String)` also returns `true`.

Specified by:
  `write` in interface `PropertyAccessor`
Parameters:
  `context` - the evaluation context in which the access is being attempted
  `target` - the target object upon which the property is being accessed
  `name` - the name of the property being accessed
  `newValue` - the new value for the property
Throws:
  `AccessException` - if there is any problem writing to the property value

### findGetterForProperty

@Nullable protected Method findGetterForProperty(String propertyName, Class<?> clazz, boolean mustBeStatic)
Find a getter method for the specified property.

### findSetterForProperty

@Nullable protected Method findSetterForProperty(String propertyName, Class<?> clazz, boolean mustBeStatic)
Find a setter method for the specified property.

### isCandidateForProperty

protected boolean isCandidateForProperty(Method method, Class<?> targetClass)
Determine whether the given `Method` is a candidate for property access on an instance of the given target class.

The default implementation considers any method as a candidate, even for non-user-declared properties on the `Object` base class.

Parameters:
  `method` - the Method to evaluate
  `targetClass` - the concrete target class that is being introspected
Since:
  4.3.15

### getPropertyMethodSuffixes

protected String[] getPropertyMethodSuffixes(String propertyName)
Return the method suffixes for a given property name. The default implementation uses JavaBean conventions with additional support for properties of the form 'xY' where the method 'getXY()' is used in preference to the JavaBean convention of 'getxY()'.

### getPropertyMethodSuffix

protected String getPropertyMethodSuffix(String propertyName)
Return the method suffix for a given property name. The default implementation uses JavaBean conventions.

### findField

@Nullable protected Field findField(String name, Class<?> clazz, boolean mustBeStatic)
Find a field of a certain name on a specified class.

### createOptimalAccessor

public PropertyAccessor createOptimalAccessor(EvaluationContext context, @Nullable Object target, String name)
Attempt to create an optimized property accessor tailored for a property of a particular name on a particular class.

The general `ReflectivePropertyAccessor` will always work but is not optimal due to the need to look up which reflective member (method or field) to use each time `read(EvaluationContext, Object, String)` is called.

This method will return this `ReflectivePropertyAccessor` instance if it is unable to build an optimized accessor.

Note: An optimized accessor is currently only usable for read attempts. Do not call this method if you need a read-write accessor.